---
- name: find existing users
  find:
    paths: "/home/{{ ansible_facts.user_id }}/users"
    recurse: no
    file_type: directory
  register: mail_user_dirs

- name: turn existing users into list
  set_fact:
    existing_mail_accounts: "{{ ( mail_user_dirs.files | map(attribute='path') | map('regex_replace', '^.+/users/(.+)', '\\1') | list ) }}"

- name: remove mail account
  # iterate the subdirectories of ~/users/ as `item`
  with_items: "{{ existing_mail_accounts }}"
  # if there is no respective mail account specified by the user
  when: item not in mail_accounts
  # we remove the account
  command:
    cmd: "{{ mail_accounts_tool_del_command }} {{ item }}"
    chdir: "{{ mail_accounts_tool_chdir }}"
    # is false during tests to disable warnings for mock commands, otherwise true, so that warnings are given
    warn: "{{ mail_accounts_tool_command_warnings }}"

- name: add mail account
  # iterate the user specified accounts as `item`
  with_items: "{{ mail_accounts }}"
  # if there is no respective directory (users/{{ item }})
  when: item not in existing_mail_accounts
  # we add the account
  vars:
    # we create or lookup a stored password. This password can be looked up in ./credentials/{user}
    password: "{{ lookup('password', '.credentials/' + item +' chars=ascii_letters,digits,hexdigits,punctuation') }}"
  command:
    cmd: "{{ mail_accounts_tool_add_command }} {{ mail_accounts_tool_password_param }}{{ password }} {{ item }}"
    chdir: "{{ mail_accounts_tool_chdir }}"
    # is false during tests to disable warnings for mock commands, otherwise true, so that warnings are given
    warn: "{{ mail_accounts_tool_command_warnings }}"
